#include <bits/stdc++.h>
using namespace std;
int main()
{
    int t,k;
    cin>>t;
int n;
cin >> n;
cin>>k;
vector<int> a(n);
for (int i = 0; i < n; i++)
cin >> a[i];

int s=0;
for(int i=0;i<n;i++){
    if (a[i]>s)
    s++;
    else
    s--;
}
if (s=k)
    cout<<"DA"<<endl;{
for (int i = 0; i < n; i++)
cout<< a[i]<<" "<<endl;
return 0;}


if(t==0)
    cout<<"DA"<<endl;
else
    cout<<"NE"<<endl;
return 0;

}